"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Duplicated in express-postgres-demo/replay/src/diff-category.ts
 *
 * Ignores:
 * "createdAt": "2023-07-13T07:00:37.193Z"
 * "timeLeft": 32322.036
 * "requestId": "e1dfdff3-0027-41a9-bc93-457acef1400f"
 * "timeRemaining": -93
 * "totalTime": -1
 *
 * not:
 * "totalTime": 1
 * "newRequests": 0
 * "paytm_cb_url": "https://securegw.paytm.in/theia/paytmCallback?ORDER_ID=C7210"
 * "razorpay_key": "rzp_test_rG2mpfkVJ3gytk"
 * "traceparent": "00-6cb840eb37797ba4be44a3cb0cbb2d0b-311cd7276ba1537e-01"
 */
function shouldIgnore(left, right) {
    if (left.trim() === right.trim())
        return true;
    var _a = getJsonKeyValue(left), leftKey = _a.key, leftValue = _a.value;
    var _b = getJsonKeyValue(right), rightKey = _b.key, rightValue = _b.value;
    if (!leftKey || !rightKey || leftKey !== rightKey) {
        return false;
    }
    if (isUuid(leftValue) && isUuid(rightValue))
        return true;
    if (isDate(leftValue) && isDate(rightValue))
        return true;
    if (isIgnoredNumber(leftValue) && isIgnoredNumber(rightValue))
        return true;
    return false;
}
exports.shouldIgnore = shouldIgnore;
function isUuid(value) {
    return /^[0-9a-f]{8}-[0-9a-f]{4}-[0-5][0-9a-f]{3}-[089ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(value);
}
function isDate(value) {
    return /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}.*/.test(value);
}
function isIgnoredNumber(value) {
    var number = Number(value);
    return !Number.isNaN(number) && value.length > 10;
}
/**
 *
 * @param line '    "createdAt": "2023-07-13T07:00:37.193Z",'
 * @returns { 'createdAt', '2023-07-13T07:00:37.193Z' }
 */
function getJsonKeyValue(line) {
    var parts = line.split('": ')
        .map(function (part) { return part.trim(); });
    if (parts.length !== 2) {
        return {};
    }
    var value = parts[1];
    if (value.startsWith('"'))
        value = value.substring(1);
    if (value.endsWith(','))
        value = value.substring(0, value.length - 1);
    if (value.endsWith('"'))
        value = value.substring(0, value.length - 1);
    return {
        key: parts[0].substring(1),
        value: value,
    };
}
